#ifndef TEAM_H
#define TEAM_H

#include <vector>

#include "glm/vec3.hpp"

#include "coord.h"
#include "dude.h"
#include "behavior.h"

#define NB_STARTING_FOOD 5
#define SPAWN_COOLDOWN 30

class Team
{
    glm::vec3 m_color;
    Coord m_spawn;
    int m_spawnCooldown;
    int m_foodQuantity;
    std::vector<Dude> m_dudes;
    BehaviorFunction m_behavior;
public:
    Team();
    Team(glm::vec3 _color,Coord _spawn,BehaviorFunction _behavior);
    bool updateSpawn();
};

#endif // TEAM_H
